//+------------------------------------------------------------------+
//|                                                       Matrik.mq4 |
//|                        Copyright 2013, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_color2 Red
//---- input parameters
extern int AtrPeriod=14;
extern int MatrPeriod=14;
//---- buffers
double AtrBuffer[];
double MatrBuffer[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(2);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,AtrBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,MatrBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Matrik("+AtrPeriod+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"MA("+MatrPeriod+")");
//----
   SetIndexDrawBegin(0,AtrPeriod);
   SetIndexDrawBegin(1,AtrPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Average True Range                                               |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   int limit;
   int counted_bars=IndicatorCounted();
   
   //---- check for possible errors
   if(counted_bars<0) return(-1);
   
   //---- last counted bar will be recounted
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
   
      //--- main loops 1 and 2
   for(i=0; i<limit; i++)   
   {
        AtrBuffer[i]=iATR(Symbol(),0,AtrPeriod,i);
      }
  
   for(i=0; i < limit; i++)
      {
        MatrBuffer[i]=iMAOnArray(AtrBuffer,0,MatrPeriod,0,MODE_SMA,i);
      }
      
      

    return(0);
  }
//+------------------------------------------------------------------+